<!DOCTYPE html>
<html>

<head>
	<meta charset="utf-8" />
	<link rel="stylesheet" type="text/css" href="https://fonts.googleapis.com/css?family=Product+Sans%3A500">
	<link rel="stylesheet" type="text/css" href="/main.css">
</head>

<body>
<!-- <h1>µBOLTS</h1>-->
<logo></logo>

<div class="container">
	<video controls></video>
	<div id="instructions">
		<h1></h1>
		<div></div>

		<button id="next" style="float: right;"></button>
	</div>
</div>

<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.3.1/jquery.min.js"></script>
<script type="text/javascript" src="microbolts.js"></script>
<script>
	var stage = 'ASK_AUTHORIZATION';
	updateInstructions();

	function updateInstructions(data) {
		console.log(stage, data);

		$('#instructions > div').empty();
		$('#next').off('click');
		$('#next').show();

		switch(stage) {
			case 'ASK_AUTHORIZATION':
				$('#instructions > h1').html('Waiting For Your Authorization');

				$('#instructions > div').append('<p>I will ask you for a payment authorization in a few moments: this is just to make sure that you really want to send payment to this website in the future.</p>');

				$('#instructions > div').append('<p>You can enable the Auto-Payment feature to let the extension handle all the payments in background for you, without compromising the safety of your funds: your Lightning node is still going to filter all the requests and block them if your spending limit is exceeded.</p>');		

				$('#next').html('Let\'s go!');
				$('#next').click(function () {
					askAuthorization();

					$(this).off('click');
				});

				break;

			case 'AUHORIZED':
				if (data.automatic) {
					$('#instructions > h1').html('To The Moon! 🚀🚀');
				} else {
					$('#instructions > h1').html('To The Moon! 🚀 (kinda at least)');
				}

				if (data.automatic) {
					$('#instructions > div').append('<p>I got your authorization, I will now start playing video. I will send you a notification every time a payment is made, so that you can really <i>feel</i> how fast Lightning is!</p>');

					$('#instructions > div').append('<p><strong>That\'s pretty much it! Enjoy and feel free to ask questions :)<strong/></p>');
				} else {
					$('#instructions > div').append('<p>I got your authorization, even though it looks like you didn\'t enable automatic payments. This is not an issue at all, it\'s just going to be a bit annoying for you to approve each payment instead of enjoying your video.</p>');

					$('#instructions > div').append('<p>Anyways, I will now start playing the video. I will send you a notification every time a payment is made, so that you can really <i>feel</i> how fast Lightning is!</p>');
				}	

				$('#next').hide();
				startVideo();

				break;

			case 'NO_EXTENSION':
				$('#instructions > h1').html('Extension Not Found');

				$('#instructions > div').append('<p>It looks like you don\'t have the µBOLTS extension installed, but don\'t worry, you can still pay manually each segment of the video (even if it\'s kind of a pain :/ )</p>');

				$('#instructions > div').append('<p>Do you want to try it out anyway?</p>');

				$('#next').html('Sure');
				$('#next').click(function () {
					startVideo();

					$(this).off('click');
					$('#next').hide();
				});

				break;

			case 'NO_AUTHORIZATION':
				$('#instructions > h1').html('You Cancelled The Authorization');

				$('#instructions > div').append('<p>It looks like you cancelled the authorization, you can still watch the video, even though you will have to manually pay each invoice.</p>');

				$('#instructions > div').append('<p>Do you want to try it out anyway?</p>');

				$('#next').html('Sure');
				$('#next').click(function () {
					startVideo();

					$(this).off('click');
					$('#next').hide();
				});

				break;
		}
	}

	function askForPayment(bolt11, cb) {
		if (stage === 'AUHORIZED') {
			console.debug(bolt11);
			window.microbolts.Pay(bolt11, cb);
		} else {
			alert(bolt11);
		}
	}

	function startVideo() {
		var video = document.querySelector('video');

		var assetURL = '/chunk/frag_bunny.mp4';
		// ./mp4info frag_bunny.mp4 | grep Codec
		var mimeCodec = 'video/mp4; codecs="avc1.42C01E, mp4a.40.2"';

		var totalSegments = 5;
		var segmentLength = 0;
		var segmentDuration = 0;
		var bytesFetched = 0;
		var requestedSegments = [];

		var msgCount = 0;

		for (var i = 0; i < totalSegments; ++i) {
			requestedSegments[i] = false;
		}

		var mediaSource = null;
		if ('MediaSource' in window && MediaSource.isTypeSupported(mimeCodec)) {
			mediaSource = new MediaSource;
			video.src = URL.createObjectURL(mediaSource);
			mediaSource.addEventListener('sourceopen', sourceOpen);
		} else {
			console.error('Unsupported MIME type or codec: ', mimeCodec);
		}

		var sourceBuffer = null;

		function sourceOpen(_) {
			sourceBuffer = mediaSource.addSourceBuffer(mimeCodec);
			getFileLength(assetURL, function(fileLength) {
				segmentLength = Math.round(fileLength / totalSegments);

				checkAndFetchSegment(assetURL, 0, segmentLength, appendSegment);

				requestedSegments[0] = true;

				video.addEventListener('timeupdate', checkBuffer);
				video.addEventListener('seeking', seek);

				video.addEventListener('canplay', function() {
					segmentDuration = video.duration / totalSegments;
					video.play();
				});
			});
		};

		function getFileLength(url, cb) {
			var xhr = new XMLHttpRequest;
			xhr.open('head', url);
			xhr.onload = function() {
				cb(xhr.getResponseHeader('content-length'));
			};
			xhr.send();
		};

		function fetchInvoice(start, end, cb) {
			var xhr = new XMLHttpRequest;
			xhr.open('get', '/invoice?start=' + start + '&end=' + end);
			xhr.onload = function() {
				cb(JSON.parse(xhr.response));
			};
			xhr.send();
		}

		function checkAndFetchSegment(url, start, end, cb) {
			var xhr = new XMLHttpRequest;
			xhr.open('get', '/chunk_available?start=' + start + '&end=' + end);
			xhr.onload = function() {
				if (xhr.status == 200) {
					fetchRange(url, start, end, cb);
				}
			};

			xhr.onloadend = function() {
				if (xhr.status == 403) {
					fetchInvoice(start, end, function(invoice) {
						askForPayment(invoice.bolt11, function(err, _) {
							if (err) {
								return console.error(err);
							}

							var messages = [
								'Hey! Just made another payment! ⚡⚡',
								'Yeah, it\'s me again: just paid an invoice!',
								'Sorry to bother but.. yeah, you can guess it',
								'Say goodbye to your precious satoshis 👋👋',
							];

							Notification.requestPermission(function (permission) {
						      if (permission === "granted") {
						      	var msg = msgCount == 0 ? 'Hey! Just made a payment! ⚡⚡' : messages[Math.floor(Math.random() * messages.length)];
						        var notification = new Notification(msg);

						        msgCount++;
						      }
						    });

							fetchRange(url, start, end, cb);
						});
					});
				}
			}
			xhr.send();
		}

		function fetchRange(url, start, end, cb) {
			var xhr = new XMLHttpRequest;
			xhr.open('get', url);
			xhr.responseType = 'arraybuffer';
			xhr.setRequestHeader('Range', 'bytes=' + start + '-' + end);
			xhr.onload = function() {
				bytesFetched += end - start + 1;
				cb(xhr.response);
			};
			xhr.send();
		};

		function appendSegment(chunk) {
			sourceBuffer.appendBuffer(chunk);
		};

		function checkBuffer(_) {
			var currentSegment = getCurrentSegment();
			if (currentSegment === totalSegments && haveAllSegments()) {
				console.log('last segment', mediaSource.readyState);
				mediaSource.endOfStream();
				video.removeEventListener('timeupdate', checkBuffer);
			} else if (shouldFetchNextSegment(currentSegment)) {
				requestedSegments[currentSegment] = true;
				console.log('time to fetch next chunk', video.currentTime);
				checkAndFetchSegment(assetURL, bytesFetched, bytesFetched + segmentLength, appendSegment);
			}
		};

		function seek(e) {
			if (mediaSource.readyState === 'open') {
				sourceBuffer.abort();
				console.log(mediaSource.readyState);
			} else {
				console.log('seek but not open?');
				console.log(mediaSource.readyState);
			}
		};

		function getCurrentSegment() {
			return ((video.currentTime / segmentDuration) | 0) + 1;
		};

		function haveAllSegments() {
			return requestedSegments.every(function(val) {
				return !!val;
			});
		};

		function shouldFetchNextSegment(currentSegment) {
			return video.currentTime > segmentDuration * currentSegment * 0.6 &&
				!requestedSegments[currentSegment];
		};
	}

	function askAuthorization () {
		window.microbolts.Authorize(function(err, data) {
			if (err && err == 'CANCELLED') { // play video anyway with 'SHOW' method
				stage = 'NO_AUTHORIZATION';
				updateInstructions();
			} else if (err) {
				console.error(err);
			} else {
				stage = 'AUHORIZED';
				updateInstructions(data);
			}
		});
	}

	window.addEventListener('load', function() {
		window.microbolts.IsAuthorized(function(err, authorized, data) {
			if (err) {
				if (err === 'TIMEOUT') {
					stage = 'NO_EXTENSION';
					return updateInstructions();
				}

				return console.error(err);
			}

			if (authorized) {
				stage = 'AUHORIZED';
				updateInstructions(data);
			}
		});
	});
</script>
</body>

</html>